#include <iostream>
#include <vector>

using namespace std;

int main(){
    int n;
    cin>>n;
    vector<int> arr(n);
    for (int i=0; i<n; i++){
        cin>>arr[i];
    }
    vector<pair<int, int>> ans={};
    for (int i=0; i<n; i++){
        for (int j=0; j<n-1; j++){
            if (arr[j]>arr[j+1]){
                swap(arr[j], arr[j+1]);
                pair<int, int> aboba;
                aboba.first=j+1;
                aboba.second=j+2;
                ans.push_back(aboba);
            }
        }
    }
    cout<<ans.size()<<endl;
    for (int i=0; i<ans.size(); i++){
        cout<<ans[i].first<<" "<<ans[i].second<<endl;
    }
}